using System;
using System.Drawing;
using System.Runtime.Serialization;

namespace epitome
{
	/// <summary>
	/// A container object holding per-instance data for an epitome, that allows the program's
	/// whole working-set to be conveniently serialized and deserialized.
	/// </summary>
	[Serializable]
	public class EpitomeDocObject : IDeserializationCallback
	{
		public string InputImagePath;			// file locations for the input image and the epitome, if saved.
		public string EpitomeFilePath;
		public Bitmap InputImageBitmap;			// the original image loaded from the input file
		public bool   IsEpitomeDone;			// == false while an epitome is being computed.
		public string EpitomeShowState;
		//public Bitmap RemappedImageBitmap;	// the result of mapping an epitome back to the image
		// public bool RemappedImageIsDirty;	// a flag for whether to use the cached remapped image or to recompute
        
		public Epitome E;						// an epitome object

		public EpitomeDocObject()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void OnDeserialization(object sender) 
		{
			// nothing to do here yet, because we have no NonSerialized fields.
		}
	}
}
